unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, VCLTee.TeEngine, VCLTee.Series, VCLTee.TeeProcs,
  VCLTee.Chart;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    xEdit: TLabeledEdit;
    iEdit: TLabeledEdit;
    Chart1: TChart;
    Series1: TLineSeries;
    dltEdit: TLabeledEdit;
    minEdit: TLabeledEdit;
    Button2: TButton;
    Series2: TLineSeries;
    xmEdit: TLabeledEdit;
    Button3: TButton;
    CheckBox1: TCheckBox;
    dispEdit: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses system.Math, System.VarCmplx, Velthuis.BigIntegers,mp_real, mp_cmplx, mp_types, mp_base;

const
  NB = 120;                       // xk[C  z NB + 1
var
  BM : array of mp_float;         // xk[Cz
  NumeratorString : array[0..NB] of string;                 // q
  DenominatorString  : array[0..NB] of string;              // ֐p

  zero, one, two, three, four : mp_float;
  pai : mp_float;
  log_2pis2 : mp_complex;

// K {
procedure factorialMul(n : integer; var ans: mp_float);
label
  EXT;
var
  i : integer;
  bi : mp_float;
begin
  mpf_init(bi);

  mpf_set1(ans);
  mpf_copy(two, bi);
  if n <= 1 then begin
    goto EXT;
  end;
  for i := 2 to n do  begin
    mpf_mul(ans, bi, ans);
    mpf_add(bi, one, bi);
  end;
EXT:
  mpf_clear(bi);
end;

// ő  [Nbȟݏ@ BigInteger
function gcd_BigInteger(x, y: BigInteger): BigInteger;
var
  t : BigInteger;
begin
  while y <> 0 do begin
    t := x mod y;
    x := y;
    y := t;
  end;
  result := x;
end;

// xk[C
// Akiyama-Tanigawa algorithm
// BigInteger
procedure Bernoulli_number_BigInteger;
const
  n = (NB + 1) * 2;
var
  m, j, k : integer;
  a     : array of BigInteger;      // q
  b     : array of BigInteger;      // 
  tmpN  : BigInteger;               // q
  tmpD  : BigInteger;               // 
  gcd   : BigInteger;               // ő
  b0    : BigInteger;
begin
  setlength(a, n + 1);
  setlength(b, n + 1);
  k := 0;
  for m := 0 to n do begin
    a[m] := 1;                                      // q l
    b[m] := (m + 1);                                //  l
    for j := m - 1 downto 0 do begin
      tmpN := a[j] * b[j + 1] - a[j + 1] * b[j];    // q
      tmpN := tmpN * (j + 1);                       // V
      tmpD := b[j] * b[j + 1];                      // 
      gcd := gcd_BigInteger(tmpN, tmpD);            // ő
      a[j] := tmpN div gcd;
      b[j] := tmpD div gcd;
    end;
    if (m > 0) and (m mod 2 = 0) then begin
      b0 := b[0];                                   // log֐pɕlB̒lvZ
      b0 := b0 * m * (m -1);                        // m xk[CNo
      NumeratorString[k] := a[0].tostring;          // q
      DenominatorString[k] := b0.tostring;          // ֐p
      inc(k);
    end;
  end;
end;

// OK}{
procedure log_GammaMul(var x, ans : mp_complex);
var
  v, w, cone, ctwo : mp_complex;
  tmp, tmp0, s : mp_complex;
  i : integer;
begin
  mpc_init4(v, w, cone, ctwo);
  mpc_init3(tmp, tmp0, s);

  mpc_set1(cone);                   // 1 + 0i
  mpc_add(cone, cone, ctwo);        // 2 + 0i

  mpc_set1(v);                      // 1 + 0i
  mpc_set0(tmp);                    // 0 + 0i
  mpf_set_int(tmp.re, NB);          // NB + 0i
  while mpf_is_lt(x.re, tmp.re) do begin  //  while x < NB do
    mpc_mul(v, x, v);               // v = v * x
    mpf_add(x.re, one, x.re);       // x := x + 1
  end;
  mpc_mul(x, x, tmp);               // x^2
  mpc_div(cone, tmp, w);            // w = 1 / x^2
  mpc_set0(s);                      // s = 0 + 0i
  for i := NB downto 1 do begin
    mpc_add_mpf(s, BM[i], tmp);     // tmp = s + B[i]
    mpc_mul(tmp, w, s);             // s = tmp * w
  end;
  mpc_add_mpf(s, BM[0], tmp);       // tmp = s + B[0]
  mpc_div(tmp, x, s);               // s = (s + B[0]) / x
  mpc_add(s, log_2pis2, s);         // s = s + ln(2)/2
  mpc_ln(v, tmp);                   // ln(v)
  mpc_sub(s, tmp, s);               // s := s - ln(v)
  mpc_sub(s, x, s);                 // s := s - x
  mpc_div(cone, ctwo, tmp);         // tmp = 1/2
  mpc_sub(x, tmp, tmp0);            // tmp0 = x - 1/2
  mpc_ln(x, tmp);                   // ln(x)
  mpc_mul(tmp0, tmp, tmp0);         // tmp0 = (x - 1/2) * ln(x)
  mpc_add(s, tmp0, ans);            // ans = s + (x - 1/2) * ln(x)

  mpc_clear4(v, w, cone, ctwo);
  mpc_clear3(tmp, tmp0, s);
end;

// {K}  f
// x̒l 0 ƕ̎́ɂȂ̂ŁtOZbgl1Ԃ܂B
function gammaMul(xx : mp_complex; var ans: mp_complex) : integer;
label
  EXT;
var
  tmp, sinx, logG, cone, cpai : mp_complex;
  x : mp_complex;
begin
  mpc_init5(tmp, sinx, logG, cone, cpai);
  mpc_init(x);

  // xx̒lωxx̌lsɂȂ̂ŃRs[Ďgp܂
  mpf_read_decimal(x.re, PAnsiChar(ansistring(string(mpf_decimal(xx.re, 200)) + #00)));
  mpf_read_decimal(x.im, PAnsiChar(ansistring(string(mpf_decimal(xx.im, 200)) + #00)));

  // [Ŏ[܂ݕ̐灇
  if mpf_is0(x.im) and mpf_is_le(x.re, zero) then begin
    mpf_frac(x.re, tmp.re);               // ̏_ȉo
    if mpf_is0(tmp.re) then begin         // _ȉ[
      mpc_set0(ans);
      result := 1;                        // tOZbg
      goto EXT;                           // I
    end;
  end;

  mpc_set_mpf(cpai, pai, zero);           // + 0i
  mpc_set1(cone);                         // 1 + 0i

  if mpf_is_lt(x.re, zero) then begin     // x.real < 0
    mpc_mul_mpf(x, pai, tmp);             // x*
    mpc_sin(tmp, sinx);                   // sin(x);
    mpc_sub(cone, x, tmp);                // 1-x
    log_GammaMul(tmp, logG);              // loggamma(1-x);
    mpc_exp(logG, logG);                  // exp(loggamma)
    mpc_div(cpai, sinx, tmp);             // /sin(x)
    mpc_div(tmp, logG, ans);              // ans = /(sin(x) * logG(1-x))
  end
  else begin                              // x.real >= 0
    log_GammaMul(x, logG);                // logGamma(x)
    mpc_exp(logG, ans);                   // exp(logGamma)
  end;
  result := 0;                            // tOl

EXT:
  mpc_clear5(tmp, sinx, logG, cone, cpai);
  mpc_clear(x);
end;

// f֐vZ
procedure TForm1.Button1Click(Sender: TObject);
var
  ch, xi, dpcs: integer;
  xd, id : double;
  x, ans : mp_complex;
begin
  val(xedit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('x̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(iedit.Text, id, ch);
  if ch <> 0 then begin
    application.MessageBox('i̒lɊԈႢ܂B','',0);
    exit;
  end;
  val(dispEdit.Text, dpcs, ch);
  if ch <> 0 then begin
    application.MessageBox('\ ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if dpcs <= 5 then begin
    application.MessageBox('\ ̒l傫ĉB','',0);
    exit;
  end;

  mpc_init2(x, ans);

  // ͒leLXg`œǂݍݑ{lɕϊ܂Aϊ덷h~łB
  mpf_read_decimal(x.re, PAnsiChar(ansistring(xedit.Text + #00)));
  mpf_read_decimal(x.im, PAnsiChar(ansistring(iedit.Text + #00)));

  // (x)lvZ ch=0  ch=1 
  ch := gammaMul(x, ans);

  memo1.Clear;

  // ͒l\(PȂmFp)
  if id >= 0 then
    memo1.Lines.Append('(' + floattostr(xd) + ' +' + floatTostr(id) + 'i)') // +l\
  else
    memo1.Lines.Append('(' + floattostr(xd) + ' ' + floatTostr(id) + 'i)'); // -l\

  // vZʕ\
  if ch = 0 then begin
    memo1.Lines.Append('  ' + string(mpf_decimal(ans.re, dpcs)));                   // l\
    if mpf_is_ge(ans.im, zero) then
      memo1.Lines.Append('+' + string(mpf_decimal(ans.im, dpcs)) + ' i')      // +l\
    else
      memo1.Lines.Append(      string(mpf_decimal(ans.im, dpcs)) + ' i');     // -l\
  end
  else begin
    xi := round(xd);
    if xi mod 2 <> 0 then
      memo1.Lines.Append('-')
    else
      memo1.Lines.Append(' ');      // \
  end;

  mpc_clear2(x, ans);
end;

// vOI O[o{ϐ
procedure TForm1.Button2Click(Sender: TObject);
label
  EXT;
var
  dlt, x, xp, xm, mean  : mp_complex;
  gp, gm, meang : mp_complex;
  onec, twoc : mp_complex;
  mean0, ans : mp_complex;
  ch, min : integer;
  xd : double;
begin
  val(minEdit.Text, min, ch);
  if ch <> 0 then begin
    application.MessageBox('min ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if min > 0 then begin
    application.MessageBox('min ̒l̓[(0)菬ĂB','',0);
    exit;
  end;
  val(dltEdit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('delta ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if xd <= 1E-57 then begin
    application.MessageBox('delta ̒l1E-57傫ĂB','',0);
    exit;
  end;

  mpc_init5(dlt, x, xp, xm, mean);
  mpc_init3(gp, gm, meang);
  mpc_init2(onec, twoc);
  mpc_init2(mean0, ans);

  mpc_set0(dlt);
  mpf_read_decimal(dlt.re, PAnsiChar(ansistring(dltEdit.Text + #00)));

  series1.Clear;
  series2.Clear;

  mpc_set1(onec);                 // 1
  mpc_set0(x);
  mpc_add(onec, onec, twoc);      // 2
  mpc_add(x, dlt, xp);
  mpc_sub(x, dlt, xm);
  gammaMul(xp, gp);
  gammaMul(xm, gm);
  mpc_chs(gm, gm);
  mpc_add(gm, gp, mean);
  mpc_div(mean, twoc, mean0);     // 0̎̒l
  if not mpf_is0(mean0.re) then   // deltal̊mF
//    mpc_div(mean, mean0, ans)
  else begin
    memo1.Lines.Append('ꂪ[ɂȂ܂B');
    memo1.Lines.Append('deltal傫ĂB');
    goto EXT;
  end;

  for ch := 0 to -min do begin
    gammaMul(xp, gp);
    gammaMul(xm, gm);
    if ch mod 2 = 0 then mpc_chs(gm, gm)
                    else mpc_chs(gp, gp);
    mpc_add(gm, gp, mean);
    mpc_div(mean, twoc, meang);
    mpc_div(meang, mean0, ans);
    xd := mpf_todouble(ans.re);
//    xd := 1 / xd;
    if ch mod 2 = 0 then series1.AddXY(-ch, xd)
                    else series2.AddXY(-ch, -xd);
    mpc_sub(xp, onec, xp);
    mpc_sub(xm, onec, xm);
  end;

EXT:
  mpc_clear5(dlt, x, xp, xm, mean);
  mpc_clear3(gp, gm, meang);
  mpc_clear2(onec, twoc);
  mpc_clear2(mean0, ans);
end;


procedure TForm1.Button3Click(Sender: TObject);
var
  dlt, x, z, xp, xm, mean  : mp_complex;
  gp, gm, gp0, gm0, meang : mp_complex;
  onec, twoc : mp_complex;
  ansap, ans : mp_complex;
  xmm, gmm0, gmmx, tmp : mp_complex;
  ch, min, dpcs : integer;
  xd : double;
begin
  val(xmEdit.Text, min, ch);
  if ch <> 0 then begin
    application.MessageBox('min ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if min > 0 then begin
    application.MessageBox('x ̒l̓[(0)菬ĂB','',0);
    exit;
  end;
  val(dltEdit.Text, xd, ch);
  if ch <> 0 then begin
    application.MessageBox('delta ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if (abs(xd) > 0.1 ) then begin
    application.MessageBox('delta ̒l0傫0.1菬ĉB','',0);
    exit;
  end;
  val(dispEdit.Text, dpcs, ch);
  if ch <> 0 then begin
    application.MessageBox('\ ̒lɊԈႢ܂B','',0);
    exit;
  end;
  if dpcs <= 5 then begin
    application.MessageBox('\ ̒l傫ĉB','',0);
    exit;
  end;

  mpc_init5(dlt, x, xp, xm, mean);
  mpc_init5(gp, gm, gp0, gm0, meang);
  mpc_init3(z, onec, twoc);
  mpc_init2(ansap, ans);
  mpc_init4(xmm, gmm0, gmmx, tmp);

  memo1.Clear;
  mpc_set0(dlt);

  mpf_read_decimal(dlt.re, PAnsiChar(ansistring(dltEdit.Text + #00)));
  mpf_read_decimal(x.re, PAnsiChar(ansistring(xmEdit.Text + #00)));  // x = xmExit

  mpc_set1(onec);                 // 1
  mpc_add(onec, onec, twoc);      // 2

  if min mod 2 <> 0 then ch := -1   // xȂ-1
                    else ch := 0;   // xȂ 0
  min := abs(min);                  // |x|
  factorialMul(min, ansap.re) ;       // x!
  mpf_inv(ansap.re, ansap.re);          // 1/x!
  if ch <> 0 then mpc_chs(ansap, ansap);     // x瓚̕]

  mpc_set0(z);                    // x=0
  mpc_add(z, dlt, xp);            // 0+
  mpc_sub(z, dlt, xm);            // 0-
  mpc_sub(xm, dlt, xmm);          // 0-2
  gammaMul(xp, gp0);              // (0+)
  gammaMul(xm, gm0);              // (0-)
  gammaMul(xmm, gmm0);            // (0-2)

  mpc_add(x, dlt, xp);            // x+
  mpc_sub(x, dlt, xm);            // x-
  mpc_sub(xm, dlt, xmm);          // x-2
  gammaMul(xp, gp);               // (x+)
  gammaMul(xm, gm);               // (x-)
  gammaMul(xmm, gmmx);            // (x-2)

  if checkbox1.Checked = false then begin
    mpc_div(gp, gp0, tmp);        // tmp = (x+)/(0+)
    mpc_div(gm, gm0, ans);        // ans = (x-)/(0-)
    mpc_add(ans, tmp, tmp);       // tmp = ans + tmp
    mpc_div(tmp, twoc, ans);      // ans = tmp / 2
  end
  else begin
    mpc_div(gm, gm0, ans);       // ans = (x-)/(0-)
    mpc_div(gmmx, gmm0, tmp);    // tmp = (x-2)/(0-2)
    mpc_sub(ans, tmp, tmp);      // tmp = tmp - ans
    mpc_add(ans, tmp, ans);      // ans = ans + tmp;
  end;

  mpc_sub(ansap, ans, tmp);

  memo1.Lines.Append(string('   1/(x!)           = ' + mpf_decimal_alt(ansap.re, dpcs)));
  memo1.Lines.Append(string('(x})/(0}) = ' + mpf_decimal_alt(ans.re, dpcs)));
  memo1.Lines.Append(string('1/(x!)-(x)/(0) = ' + mpf_decimal_alt(tmp.re, dpcs)));


  mpc_clear5(dlt, x, xp, xm, mean);
  mpc_clear5(gp, gm,  gp0, gm0, meang);
  mpc_clear3(z, onec, twoc);
  mpc_clear2(ansap, ans);
  mpc_clear4(xmm, gmm0, gmmx, tmp);
end;

// 傫ȃlꍇ͗L傫܂B
procedure TForm1.FormCreate(Sender: TObject);
var
  i : integer;
  N, D, tmp : mp_float;
  ctmp : mp_complex;
begin
  mpf_set_default_decprec(500);         // L200 140̐xɕKvłB
//  mpf_set_default_decprec(100);         // L100 50̐xɕKvłB
  setlength(BM, NB + 1);                // ֐pxk[Cz

  for i := 0 to NB do mpf_init(BM[i]);

  mpf_init3(N, D, tmp);
  mpf_init5(zero, one, two, four, three);
  mpf_init(pai);
  mpc_init(log_2pis2);
  mpc_init(ctmp);

  // 0,1,2,3,4, 
  mpf_set0(zero);
  mpf_set1(one);
  mpf_set_int(two, 2);
  mpf_set_int(three, 3);
  mpf_set_int(four, 4);
  mpf_set_pi(pai);

  // ln(2)/2    f
  mpc_set0(ctmp);                       // 0 + 0i
  mpf_mul(pai, two, ctmp.re);           // 2+0i
  mpc_ln(ctmp, ctmp);                   // ln(2+0i)
  mpc_div_mpf(ctmp, two, log_2pis2);    // ln(2+0i)/2

  //  xk[Cꕪqz\쐬
  Bernoulli_number_BigInteger;

  // ƕqɕĂ郡֐pxk[C𕂓_̒lɕϊ܂B
  // ̒l֐pɕϊĂ܂B
  for i := 0 to NB do begin
    mpf_read_decimal(N, PAnsiChar(ansistring(NumeratorString[i] + #00)));
    mpf_read_decimal(D, PAnsiChar(ansistring(DenominatorString[i] + #00)));
    mpf_div(N, D, BM[i]);               // BM[]@֐pxk[Cz
  end;

  memo1.Clear;

  mpf_clear3(N, D, tmp);
  mpc_clear(ctmp);
end;


procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i : integer;
begin
  for i := 0 to NB do mpf_clear(BM[i]);
  mpf_clear5(zero, one, two, four, three);
  mpf_clear(pai);
  mpc_clear(log_2pis2);
end;


end.
